package client;

import java.net.*;
import java.io.*;
import java.util.concurrent.*;
import message.RTMsgBase;
import main.*;


/* Client side: send a text-message to host */
public class RTClientForObjectsThdd 
 extends RTClient
 { BlockingQueue schedToClientQ;
   
   public RTClientForObjectsThdd( BlockingQueue _schedToClientQ )
    { 
      schedToClientQ = _schedToClientQ;
    }
   
   public void run()
    { RTMsgBase msgToSend;
      while( true )
       {
         try
          {    // get and send the next message from the scheduler
            msgToSend = (RTMsgBase) schedToClientQ.take();
            sendMsg( msgToSend );                
          }
         catch (InterruptedException e)
          {    // if interrupted, just go back and wait at the queue again
          }
       }
    }
   
   private void sendMsg( RTMsgBase msgToSend ) 
    { 
      String servName = msgToSend.getServTo();
      short servPort = msgToSend.getPortTo();
      
      try 
       {    // making a new socket tells server on other end a msg coming in
         Socket sock = new Socket(servName, servPort);

         ObjectOutputStream os = new ObjectOutputStream(sock.getOutputStream());
         os.writeObject( msgToSend );

         sock.close();
       } 
      catch (UnknownHostException e) 
       { System.err.println(servName + " Unknown host");
         return;
       } 
      catch (NoRouteToHostException e) 
       { System.err.println(servName + " Unreachable" );
         return;
       } 
      catch (ConnectException e) 
       { System.err.println(servName + " connect refused");
         return;
       } 
      catch (java.io.IOException e) 
       { System.err.println(servName + ' ' + e.getMessage());
         return;
       }
    }
 }
