/*
 * RTMain.java
 *
 * Created on May 29, 2005, 1:56 PM
 *
 */

package main;

import peer.RTPeer;
import peer.RTParentPeerImpl;
import peer.RTPeerImpl;

/**
 *
 * @author Kevinsean Halle
 *  
 *  Main holds all of the run-times.  The console initiates all of the
 *   activity within the group of run-times.
 */
public class RTMain
 {
      /** default constructor.. build everything in the body of main*/
   public RTMain ()
    {
    }
   
   /**
    * @param args the command line arguments
    *  Create several run-times, each with a different port to listen
    *   on.  Send a message to each run-time declaring the presence of
    *   each other run-time.
    *
    *  One special run-time is the "console" run-time from which the 
    *   user constructs and sends messages that cause activity in the
    *   group of run-times.  For example, a "data message from above"
    *   sent to a run-time causes it to divide the data and send 
    *   pieces to other group members, then undivide the results and
    *   return the final answer back to the console run-time.
    */
   public static void main (String[] args)
    { int numRTToCreate = 4;
      if (args.length == 0) 
       { numRTToCreate = 4;
       } 
      else if (args.length == 1) 
       { try 
          { numRTToCreate = Integer.parseInt(args[0]);
          } 
         catch(NumberFormatException e) 
          { System.err.println("Number " + args[0] + " invalid (" + 
             e.getMessage() + ").");
            System.exit(1);
          }
       } 
      else 
       { System.err.println("usage: RTMain numberOfRunTimes");
         System.exit(1);
       }
      
      RTPeer[] theRunTimes;
      theRunTimes = new RTPeerImpl[numRTToCreate];

         // create the run-times..
      int i;
      for(i=0; i < numRTToCreate; i++)
       { 
         theRunTimes[i] = new RTPeerImpl( (short)(9900 +i), 
          (short)(9900 + numRTToCreate), numRTToCreate );
       }
      
         // create the console..
      RTParentPeerImpl theConsole = new RTParentPeerImpl( 
       (short) (9900+i), numRTToCreate );      
   
    }
 }