/*
 * RTMsgID.java
 *
 * Created on June 5, 2005, 1:52 AM
 *
 * To change this template, choose Tools | Options and locate the
 * template under the Source Creation and Management node. Right-click
 * the template and choose Open. You can then make changes to the
 * template in the Source Editor.
 */

package message;

/**
 *
 * @author Kevinsean Halle
 */
public class RTMsgID
{  int   localMsgID;
   short whoFrom;
   
   /**
    * Creates a new instance of RTMsgID 
    *   A message is uniquely identified by the pair {RTMsgID, whoFrom}
    *    because each runtime has a unique identifier (either a host
    *    name, or IP addr, or a port assigment for multiple RTs on 
    *    the same machine)
    *    and each RT maintains its own localMsgID which is unique
    *    for that particular run-time.
    */
   public RTMsgID ()
    { 
    }

   public RTMsgID ( int _localMsgID, short _whoFrom )
    { localMsgID = _localMsgID;
      whoFrom = _whoFrom;
    }

   
   public String toString()
    { String retString = "RTMsgID: "; 
      retString += " Local Msg ID: " + localMsgID; 
      retString += " Who From: " + whoFrom + "\n";
      return retString;
    }
   
   
   public void setWhoFrom( int _whoFrom )
    { whoFrom = (short) _whoFrom;
    }
   public short getWhoFrom()
    { return whoFrom;
    }
   
   
   public void setLocalMsgID( int _localMsgID )
    { localMsgID = _localMsgID;
    }
   public int getLocalMsgID()
    { return localMsgID;
    }
     
   public int hashCode()
    {
      // hash code does not have to be distinct..  collisions
      //  are caught by the equals method.
      // So, it's okay to just add localMsgID to port of who from
      return localMsgID + whoFrom;
    }
   
   public boolean equals( Object o )
    { if( !( o instanceof RTMsgID ) ) return false;
      RTMsgID other = (RTMsgID)o;
      if( localMsgID == other.getLocalMsgID() )
       { return ( whoFrom == other.getWhoFrom() );
       }
      else
       { return false;
       }
    }

 }
