/*
 * RunTimeImpl.java
 *
 * Created on May 26, 2005, 5:39 AM
 *
 */

package peer;

import java.util.concurrent.*;
import java.util.*;

/**
 *
 * @author Kevinsean Halle
 */
public class RTPeer 
 {
   protected short            portToListenOn;
   protected int              howManyRTsInGroup;
   protected short            portOfAbovePeer;
   public    int              thisRTsIndex; // tired, just hack it
   protected ArrayList<Short> portsOfOtherRTsInGroup;

   
   /**
    * Creates a new instance of RunTimeImpl 
    * Build the client, the server, the scheduler, and the queues 
    * linking them. Then start the client, server, and scheduler going
    */
   public RTPeer( short _portToListenOn, short _portOfAbovePeer,
    int _howManyRunTimesInGroup ) 
    { portToListenOn     = _portToListenOn;
      portOfAbovePeer    = _portOfAbovePeer;
      howManyRTsInGroup  = _howManyRunTimesInGroup;
      

         //  This way is flexible for future when 
         //  will have objects holding destination-addr instead of
         //  just a short.  
		portsOfOtherRTsInGroup = new ArrayList<Short>();
      short i;
         // the others with port number less than this one's
      for( i=0; i + 9900 < portToListenOn; i++ )
       {
         portsOfOtherRTsInGroup.add( new Short( (short)(9900 + i) ));
       }
      
      thisRTsIndex = i;
      
         // the others with port number larger than this one's
      for( i++ ; i < howManyRTsInGroup; i++ )
       {
         portsOfOtherRTsInGroup.add( new Short( (short)(9900 + i) ));
       }
      
      System.out.println( "ports of others: "); 
      Iterator<Short> it = portsOfOtherRTsInGroup.iterator();
      while (it.hasNext()) 
       { Short port = it.next();
         System.out.println( port );
       }

    }
   
   public short getPort()
    {
      return  portToListenOn;
    }
   
   
   public short getPortOfAbovePeer()
    {
      return  portOfAbovePeer;
    }
   
   
   public int getNumRTs()
    {
      return  howManyRTsInGroup;
    }
   
   
   public ArrayList<Short>  getPortsOfOtherRTsInGroup()
    {
      return portsOfOtherRTsInGroup;
    }
      
}
