/*
 * RTPeerImpl.java
 *
 * Created on May 26, 2005, 5:39 AM
 *
 */

package peer;

import java.util.concurrent.*;
import scheduler.*;
import server.*;
import worker.*;
import client.*;
import main.*;
import peer.RTPeer;

/**
 *
 * @author Kevinsean Halle
 */
public class RTPeerImpl extends RTPeer
 {
   protected BlockingQueue toClientQ;
   protected BlockingQueue toSchedQ;
   protected BlockingQueue toWorkerQ;
   protected RTClient      theClient;
   protected RTServer      theServer;
   protected RTWorker      theWorker;
   protected RTScheduler   theScheduler;   
     
   /**
    * Creates a new instance of RTPeerImpl 
    * Build the client, the server, the scheduler, and the queues 
    * linking them. Then start the client, server, and scheduler going
    */
   public RTPeerImpl( short _portToListenOn, 
    short _portOfAbovePeer, int _howManyRunTimesInGroup ) 
    { super(  _portToListenOn, _portOfAbovePeer, 
              _howManyRunTimesInGroup);
      
      toClientQ    = new LinkedBlockingQueue( );
      toSchedQ     = new LinkedBlockingQueue( );
      toWorkerQ    = new LinkedBlockingQueue( );

      theClient = new RTClientForObjectsThdd( toClientQ );
      theClient.start();

      theServer = new RTServerForObjectsThdd( toSchedQ, 
       portToListenOn );
      theServer.start();

      theWorker = new RTWorkerBasic( toSchedQ, toWorkerQ, this );
      theWorker.start();

      theScheduler = new RTSchedForObjectsThddGUI( 
       toClientQ, toWorkerQ, toSchedQ, (RTPeer)this );
      theScheduler.start();
    }
}
